unit Mainform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus, Richedit;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    FontDialog: TFontDialog;
    MainMenu: TMainMenu;
    Edit1: TMenuItem;
    Centerallign1: TMenuItem;
    LeftAllign1: TMenuItem;
    RightAllign1: TMenuItem;
    Font1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Clear1: TMenuItem;
    Ok1: TMenuItem;
    Exit1: TMenuItem;
    Highlightsyntax1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Open1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Save1: TMenuItem;
    SelectAll1: TMenuItem;
    StaticText1: TStaticText;
    Bold1: TMenuItem;
    mnuHelp: TMenuItem;
    procedure DelphiSyntax(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure Centerallign1Click(Sender: TObject);
    procedure LeftAllign1Click(Sender: TObject);
    procedure RightAllign1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure Bold1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuHelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var DelphiResWords : tstringlist;

Function BoldString(s : string) : integer;
var found,StartPos, ToEnd,last: Integer;
begin startpos:=0; toend:=1000000;
 with form1 do
 repeat
 found:=richedit1.FindText(trim(s), startpos, toend,[stWholeWord]);
 if found>=0 then with richedit1 do
 begin richedit1.selstart:=found; richedit1.SelLength:=length(s);
       richedit1.SelAttributes.Style:=[fsbold];
       startpos:=startpos+length(s)+1;
       if found>=0 then last:=found
 end
 until found=-1;
 result:=last
end;

procedure TForm1.DelphiSyntax(Sender: TObject);
var  i : integer;
begin
 richedit1.Lines.BeginUpdate;
 for i:=0 to DelphiResWords.Count-1 do
 BoldString(DelphiResWords.strings[i]);
 richedit1.SelLength:=0;
 richedit1.Lines.EndUpdate;
end;

procedure TForm1.Font1Click(Sender: TObject);
begin fontdialog.Font.Name:='Courier New';
 fontdialog.Font.Size:=14;
 if fontdialog.Execute=false then exit;
 with RichEdit1 do
 begin selectall;
      SelAttributes.Name:=fontdialog.font.Name;
      SelAttributes.Size:=fontdialog.Font.Size;
      SelAttributes.Color:=fontdialog.Font.Color;
      SelAttributes.Style:=fontdialog.Font.Style;
      SelLength:=0;
 end;
end;

procedure TForm1.Centerallign1Click(Sender: TObject);
begin
  RichEdit1.Paragraph.Alignment :=taCenter
end;

procedure TForm1.LeftAllign1Click(Sender: TObject);
begin
 RichEdit1.Paragraph.Alignment :=taLeftJustify
end;

procedure TForm1.RightAllign1Click(Sender: TObject);
begin
  RichEdit1.Paragraph.Alignment :=taRightJustify
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
 Richedit1.CopyToClipboard
end;

procedure TForm1.Paste1Click(Sender: TObject);
begin
 Richedit1.PasteFromClipboard
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
 Richedit1.Clear
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.execute=false then exit;
 richedit1.Lines.LoadFromFile(opendialog1.filename)
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
 if savedialog1.Execute=false then exit;
 richedit1.Lines.SaveToFile(savedialog1.filename)

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close
end;

procedure TForm1.SelectAll1Click(Sender: TObject);
begin
    richedit1.SelectAll
end;

procedure TForm1.RichEdit1SelectionChange(Sender: TObject);
var
  CharPos: TPoint;
begin
  CharPos.Y := SendMessage(richedit1.Handle, EM_EXLINEFROMCHAR, 0,
    richedit1.SelStart);
  CharPos.X := (richedit1.SelStart -
    SendMessage(richedit1.Handle, EM_LINEINDEX, CharPos.Y, 0));
  Inc(CharPos.Y);
  Inc(CharPos.X);
 statictext1.caption := Format('Line: %3d   Col: %3d', [CharPos.Y, CharPos.X]);
end;

procedure TForm1.Bold1Click(Sender: TObject);
begin
with RichEdit1 do
 begin
  if (SelAttributes.Style = [fsbold])or
     (SelAttributes.Style = [fsbold,fsitalic])
   then selattributes.Style:=selattributes.Style-[fsbold]
  else selattributes.Style:=selattributes.Style+[fsbold]
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var temp : TResourceStream;
begin DelphiResWords:=tstringlist.Create; DelphiResWords.Sorted:=false;
  //dictionary:=tstringlist.Create; dictionary.Sorted:=false;
  temp:=TResourceStream.Create(hinstance,'RESERVEDWORDS',pchar('RCDATA_1'));
  DelphiResWords.LoadFromStream(temp);
  temp.Free;

   //for i:=0 to dictionary.Count-1 do dictionary.Strings[i]:=uppercase(dictionary.Strings[i]);
   //dictionary.Sorted:=true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 DelphiResWords.Free
end;

procedure TForm1.mnuHelpClick(Sender: TObject);
begin
 showmessage('For best result first load the PAS text file and the click on File--> Highlightsyntax'+
 #13#10+'File can be saved as RTF file with highlighted words');

end;

end.
